//==================================================
//POV-Ray Main scene file innocent_part.pov
//==================================================
//Author Martial Rameaux janvier 2005
//for the POVCOMP 2004 (http://www.povcomp.com/)
//==================================================
//tools used
//PoseRay v3.8.2.327 http://user.txcyber.com/~sgalls/
//Wings3d http://www.wings3d.com/
//ColorPicker http://www.geocities.com/jamisbuck/downloads.html
//PaintShopPro demo for colored map  (Fou,Dame and Lapin)
//Xnview http://www.xnview.com/ for work-view and  convert map to jpeg 
//Chrix Colefax include explode.inc http://www.geocities.com/SiliconValley/Lakes/1434/explode.html
//HDRI map from http://www.debevec.org/
//==================================================
//Files needed to run the POV-Ray scene: 

//innocent_part.pov this file    

//pionColor_pov.inc   (geometry mesh without texture_list)
//pionMap_pov.inc     (geometry mesh)
//pionMap_pov_mat.inc (Material file)
//diffusePion.jpg     (map)

//roiColor_pov.inc   (geometry mesh without texture_list)
//roiMap_pov.inc     (geometry mesh)
//roiMap_pov_mat.inc (Material file)
//diffuseRoi.jpg     (map)

//dameColor_pov.inc   (geometry mesh without texture_list)
//dameMap_pov.inc     (geometry mesh)
//dameMap_pov_mat.inc (Material file)
//diffuseDame.jpg     (map)

//fouColor_pov.inc         (geometry mesh without texture_list)
//fouMap_pov.inc           (geometry mesh)
//fouMap_pov_mat.inc       (Material file)
//diffuseColorFou.jpg     (map)
//diffuseColorGrayFou.jpg (map)

//CavalierColor_pov.inc (geometry mesh without texture_list)
//CavalierMap_pov.inc   (geometry mesh)
//cavalierMap_pov.inc   (Material file)
//diffuseCavalier.jpg   (map)

//EtendarMap_pov.inc   (geometry mesh)
//EtendarMap_pov_mat   (Material file)
//diffuseEtendar_r.jpg (map) 
//diffuseEtendar_w.jpg (map)

//tourColor_pov.inc  (geometry mesh without texture_list)
//tour2Color_pov.inc (geometry mesh without texture_list)

//lapinMap_pov.inc     (geometry mesh)
//lapinMap_pov_mat.inc (Material file)
//diffuselapin.jpg     (map)

//uffizi_probe.hdr (hdri map http://www.debevec.org/Probes/uffizi_probe.hdr)
//==================================================
//==================================================
#version unofficial megapov 1.1;
// ------------------------------SWITCH
#declare use_rad    =1; // 0 no_rad ;1 load; 2 save;
// --------------------
#declare useAll     =1;

#declare usePion    =0;
#declare useRoi     =0;
#declare useEtendar =0;
#declare useDame    =0;
#declare useTour    =0;
#declare useTour2   =0;
#declare useFou     =0;
#declare useCavalier=0;
#declare useExplode =1;
#declare useLapin   =0;

#declare noPiece    =0;
#declare useWork    =0;
// -------------------
#if (noPiece)
    #declare usePion    =0;
    #declare useRoi     =0;
    #declare useEtendar =0;
    #declare useDame    =0;
    #declare useTour    =0;
    #declare useTour2   =0;
    #declare useFou     =0;
    #declare useCavalier=0;
    #declare useExplode =0;
    #declare useLapin   =0;
#end

#if(useAll)
    #declare usePion    =1;
    #declare useRoi     =1;
    #declare useEtendar =1;
    #declare useDame    =1;
    #declare useTour    =1;
    #declare useTour2   =1;
    #declare useFou     =1;
    #declare useCavalier=1;
    #declare useExplode =1;
    #declare useLapin   =1;
#end

// -------------------------END_SWITCH

#include "colors.inc"
#include "skies.inc"
#include "stars.inc"
#include "textures.inc"


// ------------ 
#declare rad_brightness=1.0;
#declare L_color=<1,1,.98>;
// ------------
global_settings {
#if(use_rad)    
radiosity {
    #if (use_rad=2)
    // save settigns
    pretrace_start .05 pretrace_end .01
    count 200 nearest_count 20 error_bound .25
    recursion_limit 1
    normal on
    brightness rad_brightness
    save_file "in_rad.rad"
   #else
    // load settings
    pretrace_start 1 pretrace_end 1
    always_sample off
    error_bound .25
    recursion_limit 1
    normal on
    brightness rad_brightness
    load_file "in_rad.rad"
   #end
  }
    #end 
 }
 
// ------------CAMERA 
//Zoom 
//col 800/ 5  =160
//row 400/ 5  = 80

// 1er Zoom pour 1600/800
//col 480  -> 640 
//row 250  -> 330
//-w8000 -h4000 +fs +ije_30 +o_30zoom +sc0.60 +sr0.625 +ec0.8 +er0.825 +a0.3

// 2e Zoom
//col 330  -> 490 
//row 243  -> 323
//-w8000 -h4000 +fs +sc0.4125 +sr0.6075 +ec0.6125 +er0.8075 +a0.3 +o_zoom_2.bmp


camera {
        location <0,0,-60>
        look_at <0,1.25,0>
        right x*image_width/image_height
        up y
        angle 21// horizontal FOV angle 15
        rotate x* 30
        rotate y* 60 //60
}

// ------------ SET lIGHT
#if(use_rad)
        #declare Lux=0.2; 
        #declare Luxap=0.2;
        #declare LuxPion=0.2;
#else
        #declare Lux=1.0*.5; 
        #declare Luxap=0.82*.5;
        #declare LuxPion=0.825*.5;
#end
//------------

light_source {
              <100,200,-100> //light position
             color rgb L_color*Lux
             //area_light x*2,z*2,7,7 //jitter adaptive 1
             parallel  point_at <0,0,0>
             }
  
     
light_source {
              <-0,100,100> //light position
              color rgb <1,.3,.3>*Luxap
              //parallel point_at <0,0,0>
             shadowless
             }  
          
light_source {
              <10,100,100> //light position
              color rgb <.3,1,.3>*Luxap
              //parallel  point_at <0,0,0>
             shadowless
             }  
light_source {
              <-10,100,0> //light position
              color rgb <.3,.3,1>*Luxap
              //parallel  point_at <0,0,0>
              shadowless
             }  
            
// ------------DEFAUT
#default {finish{ambient 0 diffuse 1 brilliance 0 reflection {0,0}}}
// -------------BACKGROUND
sky_sphere {  pigment{rgb<0.7686275,0.745098,0.7019608> }}
#declare imHDR="map/uffizi_probe.hdr" 
//sky_sphere {pigment{rgb<0.7686275,0.745098,0.7019608>  }}
sphere { 0,10000
  pigment {rgb <.8,.9,1>}
  finish{ambient .6 diffuse .6}
  no_shadow
  hollow
}

// -------------PLAN ECHIQUIER 

box{<-.5,-.3,-.5><.5,-.35,.5> pigment{rgb 0.6} scale <1000,1,1000>} //plan
box{<-.5,-.3,-.5><.5,-.1,.5>  pigment{checker rgb .6,rgb 0.2 scale 1/8.5 } scale <17,1,17>} //sous-echiquier
box{<-.5,-.1,-.5><.5,0.00,.5> pigment{checker rgb .0,rgb 1 scale 1/8 } finish{ambient .0 diffuse 1 brilliance 20 reflection {0.0,1}} scale <16,1,16>}// echiquier

// -------------FOR_WORK
#declare Work=union{ 
        #declare R=1.5;
        superellipsoid{<.3,.3> // sphere{y,R
        translate y*1.5
        }
        sphere{0,1 translate y*3 }         
        pigment{rgb 0 transmit .0}
        finish{ambient 0.0 diffuse 0 brilliance 10 metallic reflection {.8,1} specular 1 roughness 0.000001}
hollow
}
//----------------------TEXTURE DES PIECES
#declare T_Noir=texture{
        #declare P_Red=color rgb <0.325,0.102,0.024>;
         pigment {
		aoi <1, .2, 1>
		color_map {
			[0.0 Blue*.3]
			[1.0 P_Red]
			}
        }
        finish{specular 2 roughness 0.003  diffuse 1 ambient 1  reflection{0,.01} brilliance 2} 
        }

#declare T_Blanc=texture{
       // pigment {color rgb 1 transmit .0} 
         pigment {
		aoi <1, .2, 1>
		color_map {
			[0.6 White]
			[1.0 Blue]
			}
        }
        finish{specular 1 roughness 0.001 diffuse 1 ambient .0 metallic reflection{0,.01} brilliance 2}
        }
        
        
#declare T_Explode=texture{
        pigment {
		aoi <1, .2, 1>
		color_map {
			[0.60 P_Red*2]
			[0.90 Blue]
			[0.95 White ]
			}
        }
        finish{specular 1 roughness 0.001 diffuse .6 ambient .3 reflection{0.0,0}}
   }
//---------------------------------
#local Light1=light_source{<-100,200, 100>,<.95,.95,.94>*LuxPion shadowless }
#local Light2=light_source{< 100,200,-100>,<.94,.94,.95>*LuxPion shadowless }

#macro TrsltePiece(XZ)
        #local X=asc(strlwr(substr(XZ,1,1)))-asc("a")+1;
        #local Z=val(substr(XZ,2,1));
        translate <-7,0,-7>+<X-1, 0, Z-1>*2
#end


// Piece(P,XZ,N,R): Piece, ligne-Colonne, Color, Rotation.
#macro Piece(P,XZ,N,R)
	    #local X=asc(strlwr(substr(XZ,1,1)))-asc("a")+1;
        #local Z=val(substr(XZ,2,1));
        light_group{
        Light1  Light2
        object{P texture{T_Blanc} #if(N)texture{T_Noir}#end hollow} 
        #if(N) Light1 Light2 Light2 rotate y*180 #end   
        rotate y*R TrsltePiece(XZ)//translate <-7,0,-7>+<X-1, 0, Z-1>*2//TransPiece(file,Z)
        global_lights on
        }
#end


#macro PieceM(P,XZ,N,R)//miroire en X
	    #local X=asc(strlwr(substr(XZ,1,1)))-asc("a")+1;
        #local Z=val(substr(XZ,2,1));
        light_group{
        Light1  Light2 
        object{P texture{T_Blanc} #if(N)texture{T_Noir}#end scale <-1,1,1> hollow} 
        #if(N) Light1 Light1 Light1 #end   
        rotate y*R  TrsltePiece(XZ)//translate <-7,0,-7>+<X-1, 0, Z-1>*2//TransPiece(file,Z)
        global_lights on
        }
#end

// -------------------
// Geometry sans map = pieceColor_pov.inc
// Geometry avec map = pieceMap_pov.inc
// ---------------PION
#declare B=0;
#declare N=1;

#if(usePion) 
        #include "PionColor_pov.inc" 
        Piece(Pion,"a7",N,20)
      //Piece(Pion,"b7",N,30)
        Piece(Pion,"c7",N,20)
       PieceM(Pion,"d7",N,70)
        Piece(Pion,"e5",N,70)
        Piece(Pion,"f7",N,80)
      //Piece(Pion,"g6",N,30)
        Piece(Pion,"h6",N,70)  

   //--------geometrie with map
       #include "PionMap_pov.inc"
        Piece(Pion,"a2", B,0)
        Piece(Pion,"b3", B,0)
        Piece(Pion,"c2", B,0)
        Piece(Pion,"d2", B,80)
        Piece(Pion,"e4", B,0)
       PieceM(Pion,"f2",B,-80)
        Piece(Pion,"g2", B,0)
        Piece(Pion,"h2", B,0)
        
#end    
 //------------EXPLODE PIECE
 #if(useExplode)
   #include "PionColor_pov.inc" 
   #declare particle_texture = T_Noir
   #declare particle_object = object{Pion texture{T_Noir}}
   #declare explode_object  = object{Pion texture{T_Explode}}  // box{-1,1 texture{T_Blanc} scale 1}
   
      #declare exp_location = <0, 0, 0>;
      #declare exp_strength = 3;
      #declare exp_spin = .1;
      #declare exp_seed = 632;
      #declare exp_turb = .1;
      #declare scale_turb = .1;
      #declare rotate_turb = .1;
      #declare vel_turb = .1;
      #declare dir_turb = .1;
      #declare spin_turb = .1;
   
   #declare explode_clock = 0.18;
   #declare object_hollow = 1;
   #declare exp_turb = .1;
   #declare Explode=union{#include "Explode.inc"}
   object{Explode TrsltePiece("b4")}    
#end   
//-------------FOU
#if(useFou)
    #declare Color=1; //Colored Map
    #include "fouMap_pov.inc" 
    Piece(Fou,"c1",B,0)
   
    #declare Color=0; //Black and White map
    #include "fouMap_pov.inc" 
    Piece(Fou,"f1",B,0)
       
   #include "fouColor_pov.inc"
        Piece(Fou,"c8",N,0)
        Piece(Fou,"f8",N,0)
#end
//-------------DAME
#if(useDame) 
        #include "DameMap_pov.inc" 
        Piece(Dame,"g4",B,-60) 
        
        #include "DameColor_pov.inc"
        Piece(Dame,"d8",N, 0)
#end

//-------------ROI
#if(useRoi) 
        #include "RoiMap_pov.inc"  
        Piece(Roi,"e1",B,-30) 
        
        #include "RoiColor_pov.inc" 
        Piece(Roi,"e8",N,0)
#end

//-------------ETENDARS
#if(useEtendar)
        #local ETnd=0;
        #include "EtendarMap_pov.inc" 
        object{Piece(Etendar,"e1",B,-80) translate <1,0,1>}
        #local ETnd=1;
        #include "EtendarMap_pov.inc" 
        object{Piece(Etendar,"e8",N,30) translate <-1,0,-1>}
#end
//------------TOURS
#if(useTour) 
        #include "tourColor_pov.inc" 
        Piece(Tour,"a8",N,0)
        Piece(Tour,"a1",B,0)
        Piece(Tour,"h1",B,0)
#end

#if(useTour2)  #include "tour2Color_pov.inc" 
Piece(Tour2,"h8",N,05)
#end
//---------------CAVALIER
#if(useCavalier)
        #include "CavalierMap_pov.inc"  
        Piece(Cavalier,"b1",B,-90)
        Piece(Cavalier,"g1",B,-90)
        
        #include "CavalierColor_pov.inc" 
        Piece(Cavalier,"b8",N,-90)
        Piece(Cavalier,"g8",N,-90)
#end
//----------------Lapin
#if(useLapin)
#include "lapinMap_pov.inc" 
object{Lapin scale 0.53 rotate y*210 TrsltePiece("d4") translate <0,0,.5>}
#end
//---------------WORK
#if(useWork)
        object{Work translate <-7,-.3,-7>+<3-1,-.3, 4-1>*2} 
#end
//==================================================
